<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { ref, onMounted, nextTick } from 'vue';

defineProps<{
    label: string,
    colorClass: string
}>();
const mounted = ref(false);
const isHover = ref(false);
const labelRef = ref<HTMLElement>();
const labelWidth = ref(0);

const handleHoverStart = () => {
    isHover.value = true;
};

const handleHoverEnd = () => {
    isHover.value = false;
};

onMounted(()=>{
    nextTick(() => {
        if (!labelWidth.value) {
            const labelElement = labelRef.value as HTMLElement;
            labelWidth.value = labelElement.offsetWidth;
        }
        mounted.value = true;
    });
})

</script>
<template>
    <div>
        <div @touchstart="handleHoverStart" @touchend="handleHoverEnd" @mouseenter="handleHoverStart"
            @mouseleave="handleHoverEnd"
            class="inline-block relative text-center transition-all duration-300 rounded-full h-4 leading-4 min-w-4 text-[10px]"
            :class="colorClass" :style="{ 'width': isHover ? `${labelWidth}px!important` : '16px!important' }">
            {{ isHover ? label : label[0] }}

        </div>
        <div ref="labelRef" class="px-0.5 opacity-0" v-if="!mounted">
            {{ label }}
        </div>
    </div>
</template>
